#include "../../../lib/std.mi"

Function initConfiguration();

Global Layer layerNormalGlass, layerClassicGlass, layerStickGlass, layerMiniGlass, layerEQNormalGlass, layerEQStickGlass, layerThingerNormalGlass, layerPLEditStickGlassLeft, layerPLEditStickGlassMiddle, layerPLEditStickGlassRight;
Global Text textNormalSongTicker, textClassicSongTicker, textStickSongTicker;
Global Slider sliderGlassOpacity;
Global Slider sliderVolumeButtonRate;
Global Slider sliderTabAnimationSpeed;
Global Button buttonSongTickerEnabled;
Global GuiObject titleboxConfigureGlass;
Global GuiObject titleboxConfigureVolumeButtons;
Global GuiObject titleboxConfigureTabAnimationSpeed;

System.onScriptLoaded() {
	Layout layoutMainNormal = System.getContainer("main").getLayout("normal");
	Layout layoutMainClassic = System.getContainer("main").getLayout("classic");
	Layout layoutMainStick = System.getContainer("main").getLayout("stick");
	Layout layoutMainMini = System.getContainer("main").getLayout("mini");
	Layout layoutEQNormal = System.getContainer("equalizer").getLayout("normal");
	Layout layoutEQStick = System.getContainer("equalizer").getLayout("stick");
	Layout layoutThingerNormal = System.getContainer("thinger").getLayout("normal");
	Layout layoutConfigureNormal = System.getContainer("configure").getLayout("normal");
	Layout layoutPLEditStick = System.getContainer("PLEdit").getLayout("stick");
	
	Group groupNormalDisplay = layoutMainNormal.getObject("player.normal.group.display");
	Group groupClassicDisplay = layoutMainClassic.getObject("player.classic.group.display");
	Group groupStickDisplay = layoutMainStick.getObject("player.stick.group.display");
	Group groupPLEditStickDisplay = layoutPLEditStick.getObject("pledit.stick.content.group");
	
	Group groupNormalDisplayCover = layoutMainNormal.getObject("player.normal.group.display.cover");
	Group groupClassicDisplayCover = layoutMainClassic.getObject("player.classic.group.display.cover");
	Group groupStickDisplayCover = layoutMainStick.getObject("player.stick.group.display.cover");
	Group groupMiniDisplayCover = layoutMainMini.getObject("player.mini.group.display.cover");
	Group groupEQNormalDisplayCover = layoutEQNormal.getObject("equalizer.normal.group.display.cover");
	Group groupEQStickDisplayCover = layoutEQStick.getObject("equalizer.stick.group.display.cover");
	Group groupThingerNormalDisplayCover = layoutThingerNormal.getObject("thinger.normal.group.display.cover");
	
	Group groupConfigureContent = layoutConfigureNormal.getObject("configure.content.group");
	
	GuiObject guiTabsheet = groupConfigureContent.getObject("TabSheet");
	
	Group groupConfigureGeneralFrame = guiTabsheet.findObject("configure.general");
	
	titleboxConfigureGlass = groupConfigureGeneralFrame.getObject("Glass");
	titleboxConfigureVolumeButtons = groupConfigureGeneralFrame.getObject("VolumeButtons");
	GuiObject titleboxConfigureTabs = groupConfigureGeneralFrame.getObject("Tabs");
	GuiObject titleboxConfigureSongTicker = groupConfigureGeneralFrame.getObject("SongTicker");

	titleboxConfigureTabAnimationSpeed = titleboxConfigureTabs.findObject("TabAnimationSpeed");
	
	sliderGlassOpacity = titleboxConfigureGlass.findObject("glass.opacity.slider");
	
	layerNormalGlass = groupNormalDisplayCover.getObject("PlayerGlass");
	layerClassicGlass = groupClassicDisplayCover.getObject("PlayerGlass");
	layerStickGlass = groupStickDisplayCover.getObject("PlayerGlass");
	layerMiniGlass = groupMiniDisplayCover.getObject("PlayerGlass");
	layerEQNormalGlass = groupEQNormalDisplayCover.getObject("EqualizerGlass");
	layerEQStickGlass = groupEQStickDisplayCover.getObject("EqualizerGlass");
	layerThingerNormalGlass = groupThingerNormalDisplayCover.getObject("ThingerGlass");
	layerPLEditStickGlassLeft = groupPLEditStickDisplay.getObject("pledit.display.glass.left");
	layerPLEditStickGlassMiddle = groupPLEditStickDisplay.getObject("pledit.display.glass.middle");
	layerPLEditStickGlassRight = groupPLEditStickDisplay.getObject("pledit.display.glass.right");
	
	buttonSongTickerEnabled = titleboxConfigureSongTicker.findObject("songticker.enabled");
	textNormalSongTicker = groupNormalDisplay.getObject("PlayerSongTicker");
	textClassicSongTicker = groupClassicDisplay.getObject("PlayerSongTicker");
	textStickSongTicker = groupStickDisplay.getObject("PlayerSongTicker");
	
	sliderVolumeButtonRate = titleboxConfigureVolumeButtons.findObject("volumebutton.rate.slider");
	sliderTabAnimationSpeed = titleboxConfigureTabs.findObject("tabanimationspeed.slider");
	
	initConfiguration();
}

initConfiguration() {
	buttonSongTickerEnabled.onActivate(System.getPrivateInt("Mercury", "SongTickerEnabled", 1));
	sliderGlassOpacity.setPosition(System.getPrivateInt("Mercury", "GlassOpacity", 255));
	sliderVolumeButtonRate.setPosition(System.getPrivateInt("Mercury", "VolumeButtonRate", 3));
	sliderTabAnimationSpeed.setPosition(System.getPrivateInt("Mercury", "TabAnimationSpeed", 128));
}

sliderGlassOpacity.onSetPosition(Int intPosition) {
	layerNormalGlass.setAlpha(intPosition);
	layerClassicGlass.setAlpha(intPosition);
	layerStickGlass.setAlpha(intPosition);
	layerMiniGlass.setAlpha(intPosition);
	layerEQNormalGlass.setAlpha(intPosition);
	layerEQStickGlass.setAlpha(intPosition);
	layerThingerNormalGlass.setAlpha(intPosition);
	layerPLEditStickGlassLeft.setAlpha(intPosition);
	layerPLEditStickGlassMiddle.setAlpha(intPosition);
	layerPLEditStickGlassRight.setAlpha(intPosition);
	titleboxConfigureGlass.setXmlParam("suffix", ": " + System.integerToString(intPosition / 2.55) + "%");
}

sliderVolumeButtonRate.onSetPosition(Int intPosition) {
	if (intPosition != 0) {
		titleboxConfigureVolumeButtons.setXmlParam("suffix", ": " + System.integerToString(intPosition / 2.55) + "%");
	} else {
		sliderVolumeButtonRate.setPosition(3);
	}
}

buttonSongTickerEnabled.onActivate(Int intEnabled) {
	textNormalSongTicker.setXmlParam("ticker", System.integerToString(intEnabled));
	textClassicSongTicker.setXmlParam("ticker", System.integerToString(intEnabled));
	textStickSongTicker.setXmlParam("ticker", System.integerToString(intEnabled));
}

sliderTabAnimationSpeed.onSetPosition(Int IntPosition) {
	if (intPosition != 0) {
		titleboxConfigureTabAnimationSpeed.setXmlParam("suffix", ": " + System.floatToString(intPosition / 2.55 * 0.01, 2) + " second(s)");
	} else {
		sliderTabAnimationSpeed.setPosition(3);
	}
}