#include "../../../lib/std.mi"

Function catchSwitchButtons();

Global Container containerMain;
Global Button buttonNormalSwitch, buttonClassicSwitch, buttonStickSwitch, buttonMiniSwitch;
Global Button buttonNormalSwitchAction, buttonClassicSwitchAction, buttonStickSwitchAction, buttonMiniSwitchAction;
Global Layer layerNormalSwitch, layerClassicSwitch, layerStickSwitch, layerMiniSwitch;
Global String stringModes;
Global PopupMenu popupModes;

System.onScriptLoaded() {
	containerMain = System.getContainer("main");
	
	Layout layoutMainNormal = containerMain.getLayout("normal");
	Layout layoutMainClassic = containerMain.getLayout("classic");
	Layout layoutMainStick = containerMain.getLayout("stick");
	Layout layoutMainMini = containerMain.getLayout("mini");
	
	Group groupNormalButtons = layoutMainNormal.getObject("player.normal.group.buttons");
	Group groupClassicButtons = layoutMainClassic.getObject("player.classic.group.buttons");
	Group groupStickButtons = layoutMainStick.getObject("player.stick.group.buttons");
	Group groupMiniButtons = layoutMainMini.getObject("player.mini.group.buttons");
	
	buttonNormalSwitch = groupNormalButtons.getObject("ButtonSwitch");
	buttonClassicSwitch = groupClassicButtons.getObject("ButtonSwitch");
	buttonStickSwitch = groupStickButtons.getObject("ButtonSwitch");
	buttonMiniSwitch = groupMiniButtons.getObject("ButtonSwitch");
	
	layerNormalSwitch = groupNormalButtons.getObject("LayerButtonSwitch");
	layerClassicSwitch = groupClassicButtons.getObject("LayerButtonSwitch");
	layerStickSwitch = groupStickButtons.getObject("LayerButtonSwitch");
	layerMiniSwitch = groupMiniButtons.getObject("LayerButtonSwitch");
	
	buttonNormalSwitchAction = groupNormalButtons.getObject("ButtonSwitchNormal");
	buttonClassicSwitchAction = groupNormalButtons.getObject("ButtonSwitchClassic");
	buttonStickSwitchAction = groupNormalButtons.getObject("ButtonSwitchStick");
	buttonMiniSwitchAction = groupNormalButtons.getObject("ButtonSwitchMini");
		
	stringModes = "Normal;Classic;Stick;Mini";
	
	popupModes = new PopupMenu;
	popupModes.addCommand(System.getToken(stringModes, ";", 0), 1, 0, 0);
	popupModes.addCommand(System.getToken(stringModes, ";", 1), 2, 0, 0);
	popupModes.addCommand(System.getToken(stringModes, ";", 2), 3, 0, 0);
	popupModes.addCommand(System.getToken(stringModes, ";", 3), 4, 0, 0);
}

System.onScriptUnloading() {
	delete popupModes;
}

catchSwitchButtons() {
	if (popupModes == NULL) return;
	Int intSelection = popupModes.popAtMouse();
	if (intSelection > 0) {
		if (intSelection == 1) { buttonNormalSwitchAction.leftClick(); }
		if (intSelection == 2) { buttonClassicSwitchAction.leftClick(); }
		if (intSelection == 3) { buttonStickSwitchAction.leftClick(); }
		if (intSelection == 4) { buttonMiniSwitchAction.leftClick(); }
	
//		Something wrong with switchToLayout method? Can't make it work.
//		containerMain.switchToLayout(containerMain.getLayout(System.getToken(stringModes, ";", intSelection - 1)));
	}
	complete;
}

buttonNormalSwitch.onLeftClick() { catchSwitchButtons(); }
buttonClassicSwitch.onLeftClick() { catchSwitchButtons(); }
buttonStickSwitch.onLeftClick() { catchSwitchButtons(); }
buttonMiniSwitch.onLeftClick() { catchSwitchButtons(); }

layerNormalSwitch.onLeftButtonDown(Int intPosX, Int intPosY) { buttonNormalSwitch.leftClick(); }
layerClassicSwitch.onLeftButtonDown(Int intPosX, Int intPosY) { buttonClassicSwitch.leftClick(); }
layerStickSwitch.onLeftButtonDown(Int intPosX, Int intPosY) { buttonStickSwitch.leftClick(); }
layerMiniSwitch.onLeftButtonDown(Int intPosX, Int intPosY) { buttonMiniSwitch.leftClick(); }
