#include "../../../lib/std.mi"

Function initPausePlayButtons();
Function togglePlay(boolean boolShowPlay);
Function togglePause(boolean boolShowPause);

Global Button buttonNormalPause, buttonNormalPlay;
Global Layer layerNormalPauseIcon, layerNormalPlayIcon;

Global Button buttonClassicPause, buttonClassicPlay;
Global Layer layerClassicPauseIcon, layerClassicPlayIcon;

Global Button buttonStickPause, buttonStickPlay;

Global Button buttonMiniPause, buttonMiniPlay;

System.onScriptLoaded() {
	Layout layoutMainNormal = System.getContainer("main").getLayout("normal");
	Layout layoutMainClassic = System.getContainer("main").getLayout("classic");
	Layout layoutMainStick = System.getContainer("main").getLayout("stick");
	Layout layoutMainMini = System.getContainer("main").getLayout("mini");
	
	Group groupNormalButtons = layoutMainNormal.getObject("player.normal.group.buttons");
	Group groupClassicButtons = layoutMainClassic.getObject("player.classic.group.buttons");
	Group groupStickButtons = layoutMainStick.getObject("player.stick.group.buttons");
	Group groupMiniButtons = layoutMainMini.getObject("player.mini.group.buttons");
	
	buttonNormalPause = groupNormalButtons.getObject("buttonPause");
	buttonNormalPlay = groupNormalButtons.getObject("buttonPlay");
	layerNormalPauseIcon = groupNormalButtons.getObject("buttonPauseIcon");
	layerNormalPlayIcon = groupNormalButtons.getObject("buttonPlayIcon");
	
	buttonClassicPause = groupClassicButtons.getObject("buttonPause");
	buttonClassicPlay = groupClassicButtons.getObject("buttonPlay");
	layerClassicPauseIcon = groupClassicButtons.getObject("buttonPauseIcon");
	layerClassicPlayIcon = groupClassicButtons.getObject("buttonPlayIcon");
	
	buttonStickPause = groupStickButtons.getObject("buttonPause");
	buttonStickPlay = groupStickButtons.getObject("buttonPlay");
	
	buttonMiniPause = groupMiniButtons.getObject("buttonPause");
	buttonMiniPlay = groupMiniButtons.getObject("buttonPlay");
	
	initPausePlayButtons();
}

initPausePlayButtons() {
	togglePlay(false);
	togglePause(false);
	
	if (System.getPlayItemString() != "") {
		togglePause(true);
	} else {
		togglePlay(true);
	}
}

System.onPlay() {
	togglePlay(false);
	togglePause(true);
}

System.onPause() {
	togglePlay(true);
	togglePause(false);
}

System.onStop() {
	togglePlay(true);
	togglePause(false);
}

System.onResume() {
	togglePlay(false);
	togglePause(true);
}

togglePause(boolean boolShowPause) {
	if (boolShowPause) {
		buttonNormalPause.show();
		layerNormalPauseIcon.show();
		
		buttonClassicPause.show();
		layerClassicPauseIcon.show();
		
		buttonStickPause.show();
		
		buttonMiniPause.show();
	} else {
		buttonNormalPause.hide();
		layerNormalPauseIcon.hide();
		
		buttonClassicPause.hide();
		layerClassicPauseIcon.hide();
		
		buttonStickPause.hide();
		
		buttonMiniPause.hide();
	}
}

togglePlay(boolean boolShowPlay) {
	if (boolShowPlay) {
		buttonNormalPlay.show();
		layerNormalPlayIcon.show();
		
		buttonClassicPlay.show();
		layerClassicPlayIcon.show();
		
		buttonStickPlay.show();
		
		buttonMiniPlay.show();
	} else {
		buttonNormalPlay.hide();
		layerNormalPlayIcon.hide();
		
		buttonClassicPlay.hide();
		layerClassicPlayIcon.hide();
		
		buttonStickPlay.hide();
		
		buttonMiniPlay.hide();
	}
}