#include "../../../lib/std.mi"

Function initPausePlayButtons();
Function togglePlay(boolean boolShowPlay);
Function togglePause(boolean boolShowPause);

Global Button buttonControlPause, buttonControlPlay;
Global Layer layerControlPauseIcon, layerControlPlayIcon;

System.onScriptLoaded() {
	Group groupControlButtons = System.getScriptGroup();
	
	buttonControlPause = groupControlButtons.getObject("buttonPause");
	buttonControlPlay = groupControlButtons.getObject("buttonPlay");
	layerControlPauseIcon = groupControlButtons.getObject("buttonPauseIcon");
	layerControlPlayIcon = groupControlButtons.getObject("buttonPlayIcon");
	
	initPausePlayButtons();
}

initPausePlayButtons() {
	togglePlay(false);
	togglePause(false);
	
	if (System.getPlayItemString() != "") {
		togglePause(true);
	} else {
		togglePlay(true);
	}
}

System.onPlay() {
	togglePlay(false);
	togglePause(true);
}

System.onPause() {
	togglePlay(true);
	togglePause(false);
}

System.onStop() {
	togglePlay(true);
	togglePause(false);
}

System.onResume() {
	togglePlay(false);
	togglePause(true);
}

togglePause(boolean boolShowPause) {
	if (boolShowPause) {
		buttonControlPause.show();
		layerControlPauseIcon.show();

	} else {
		buttonControlPause.hide();
		layerControlPauseIcon.hide();
	}
}

togglePlay(boolean boolShowPlay) {
	if (boolShowPlay) {
		buttonControlPlay.show();
		layerControlPlayIcon.show();
	} else {
		buttonControlPlay.hide();
		layerControlPlayIcon.hide();
	}
}