#include "../../../lib/std.mi"

Function initTabSettings();
Function getTabAnimationSpeed();
Function moveTab(Group groupTab, Int intPosX, Int intPosY);
Function bringActiveTabDown(String stringNewActiveTab, Group groupTab, Group groupTabDummy, Timer timerTab);
Function bringActiveTabUp(Group groupTab, Group groupTabDummy, Timer timerTab, Int intPosX);
Function catchTimer(Group groupTab, Group groupTabDummy, Timer timerTab);

Global Group groupTabThinger, groupTabEQ, groupTabSettings;
Global Group groupTabDummyThinger, groupTabDummyEQ, groupTabDummySettings;
Global Button buttonTabDummyThinger, buttonTabDummyEQ, buttonTabDummySettings;
Global Button buttonTabThinger, buttonTabEQ, buttonTabSettings;

Global Int intTabPosYHigh, intTabPosYLow, intTabPosXLeft, intTabPosXMid, intTabPosXRight;
Global Timer timerTabThinger, timerTabEQ, timerTabSettings;
Global String stringActiveTab, stringActiveTabStatus;

System.onScriptLoaded() {
	Layout layoutMainClassic = System.getContainer("main").getLayout("classic");
	Group groupDisplay = layoutMainClassic.getObject("player.classic.group.display");
	Group groupTabs = groupDisplay.getObject("player.classic.group.display.tabs");
	
	groupTabThinger = groupTabs.getObject("player.classic.group.display.tab.thinger");
	groupTabEq = groupTabs.getObject("player.classic.group.display.tab.eq");
	groupTabSettings = groupTabs.getObject("player.classic.group.display.tab.settings");
	
	groupTabDummyThinger = groupTabs.getObject("player.classic.group.display.tab.dummy.thinger");
	groupTabDummyEq = groupTabs.getObject("player.classic.group.display.tab.dummy.eq");
	groupTabDummySettings = groupTabs.getObject("player.classic.group.display.tab.dummy.settings");
	
	buttonTabThinger = groupTabThinger.getObject("ButtonThingerToggle");
	buttonTabEQ = groupTabEQ.getObject("ButtonEQToggle");
	buttonTabSettings = groupTabSettings.getObject("ButtonSettingsToggle");
	
	buttonTabDummyThinger = groupTabDummyThinger.getObject("ButtonThingerToggle");
	buttonTabDummyEQ = groupTabDummyEQ.getObject("ButtonEQToggle");
	buttonTabDummySettings = groupTabDummySettings.getObject("ButtonSettingsToggle");
	
	timerTabThinger = new Timer;
	timerTabEQ = new Timer;
	timerTabSettings = new Timer;
	
	timerTabThinger.setDelay(150);
	timerTabEQ.setDelay(150);
	timerTabSettings.setDelay(150);

	initTabSettings();
}

System.onScriptUnloading() {
	delete timerTabThinger;
	delete timerTabEQ;
	delete timerTabSettings;
}

initTabSettings() {
	intTabPosYHigh = -31;
	intTabPosYLow = 0;
	
	intTabPosXLeft = 0;
	intTabPosXMid = 30;
	intTabPosXRight = 53;
	
	groupTabThinger.hide();
	groupTabEQ.hide();
	groupTabSettings.hide();
}

moveTab(Group groupTab, Int intPosX, Int intPosY) {
	groupTab.setTargetX(intPosX);
	groupTab.setTargetY(intPosY);
	groupTab.setTargetSpeed(getTabAnimationSpeed());
	groupTab.gotoTarget();
}

bringActiveTabDown(String stringNewActiveTab, Group groupTab, Group groupTabDummy, Timer timerTab) {
	stringActiveTab = stringNewActiveTab;
	System.setPrivateString("Mercury", "LastSelectedTab", stringActiveTab);
	groupTab.show();
	groupTab.bringToFront();
	groupTabDummy.hide();
	moveTab(groupTab, intTabPosXLeft, intTabPosYLow);
	stringActiveTabStatus = "SlidingDown";
	timerTab.start();
}

bringActiveTabUp(Group groupTab, Group groupTabDummy, Timer timerTab, Int intPosX) {
	moveTab(groupTab, intPosX, intTabPosYHigh);
	stringActiveTabStatus = "SlidingUp";
	timerTab.start();
}

getTabAnimationSpeed() {
	return (System.getPrivateInt("Mercury", "TabAnimationSpeed", 128)  / 2.55 * 0.01);
}

catchTimer(Group groupTab, Group groupTabDummy, Timer timerTab) {
	if (!groupTabDummy.isGoingToTarget() && stringActiveTabStatus == "SlidingDown") {
		stringActiveTabStatus = "DownPosition";
		timerTab.stop();
	}
	
	if (!groupTab.isGoingToTarget() && stringActiveTabStatus == "SlidingUp") {
		stringActiveTabStatus = "";
		groupTabDummy.show();
		groupTab.hide();
		groupTab.bringToFront();
		timerTab.stop();
	}	
}

timerTabThinger.onTimer() {
	catchTimer(groupTabThinger, groupTabDummyThinger, timerTabThinger);
}

timerTabEQ.onTimer() {
	catchTimer(groupTabEQ, groupTabDummyEQ, timerTabEQ);
}

timerTabSettings.onTimer() {
	catchTimer(groupTabSettings, groupTabDummySettings, timerTabSettings);
}

buttonTabThinger.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "DownPosition") { bringActiveTabUp(groupTabThinger, groupTabDummyThinger, timerTabThinger, intTabPosXLeft); }
}

buttonTabEQ.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "DownPosition") { bringActiveTabUp(groupTabEQ, groupTabDummyEQ, timerTabEQ, intTabPosXMid); }
}

buttonTabSettings.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "DownPosition") { bringActiveTabUp(groupTabSettings, groupTabDummySettings, timerTabSettings, intTabPosXRight); }
}

buttonTabDummyThinger.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("Thinger", groupTabThinger, groupTabDummyThinger, timerTabThinger); }
}

buttonTabDummyEQ.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("EQ", groupTabEQ, groupTabDummyEQ, timerTabEQ); }
}

buttonTabDummySettings.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("Settings", groupTabSettings, groupTabDummySettings, timerTabSettings); }
}