#include "../../../lib/std.mi"

Function initTabSettings();
Function initAnimation();
Function getDefaultTab();
Function getTabAnimationSpeed();
Function moveTab(Group groupTab, Int intPosY);
Function fadeDisplay(Int intAlpha);
Function bringActiveTabDown(String stringNewActiveTab, Group groupTab, Timer timerTab, Boolean boolFadeDisplay);
Function bringActiveTabUp(Group groupTab, Group groupTabDummy, Int intPosY);
Function finalizeDisplay(Timer timerTab, Int intPosY, boolean boolRestoreDisplay);
Function finalizeDisplayUtil(Group groupTabDummy, Group groupTab, Int intPosY);
Function catchTimer(Group groupTabDummy, Group groupTab, Timer timerTab, Int intPosY, Boolean boolRestoreDisplay);

Global Group groupTabThinger, groupTabEQ, groupTabVis, groupTabSettings;
Global Group groupTabDummyThinger, groupTabDummyEQ, groupTabDummyVis, groupTabDummySettings;
Global Button buttonTabDummyThinger, buttonTabDummyEQ, buttonTabDummyVis, buttonTabDummySettings;
Global Layer layerDisplayScreen;
Global Int intTabPosYHigh, intTabPosYMed, intTabPosYLow, intTabPosX;
Global Timer timerTabThinger, timerTabEQ, timerTabVis, timerTabSettings;
Global String stringActiveTab, stringActiveTabStatus;

System.onScriptLoaded() {
	Layout layoutMainNormal = System.getContainer("main").getLayout("normal");
	Group groupDisplay = layoutMainNormal.getObject("player.normal.group.display");
	Group groupTabs = groupDisplay.getObject("player.normal.group.display.tabs");
	
	layerDisplayScreen = groupDisplay.getObject("PlayerDisplayBackgroundScreen");
	
	groupTabThinger = groupTabs.getObject("player.normal.group.display.tab.thinger");
	groupTabEq = groupTabs.getObject("player.normal.group.display.tab.eq");
	groupTabVis = groupTabs.getObject("player.normal.group.display.tab.vis");
	groupTabSettings = groupTabs.getObject("player.normal.group.display.tab.settings");
	
	groupTabDummyThinger = groupTabs.getObject("player.normal.group.display.tab.dummy.thinger");
	groupTabDummyEq = groupTabs.getObject("player.normal.group.display.tab.dummy.eq");
	groupTabDummyVis = groupTabs.getObject("player.normal.group.display.tab.dummy.vis");
	groupTabDummySettings = groupTabs.getObject("player.normal.group.display.tab.dummy.settings");
	
	buttonTabDummyThinger = groupTabDummyThinger.getObject("ButtonThingerToggle");
	buttonTabDummyEQ = groupTabDummyEQ.getObject("ButtonEQToggle");
	buttonTabDummyVis = groupTabDummyVis.getObject("ButtonVisToggle");
	buttonTabDummySettings = groupTabDummySettings.getObject("ButtonSettingsToggle");
	
	timerTabThinger = new Timer;
	timerTabEQ = new Timer;
	timerTabVis = new Timer;
	timerTabSettings = new Timer;
	
	timerTabThinger.setDelay(150);
	timerTabEQ.setDelay(150);
	timerTabVis.setDelay(150);
	timerTabSettings.setDelay(150);

	initTabSettings();
	initAnimation();
}

System.onScriptUnloading() {
	delete timerTabThinger;
	delete timerTabEQ;
	delete timerTabVis;
	delete timerTabSettings;
}

initTabSettings() {
	intTabPosYHigh = -27;
	intTabPosYMed = 0;
	intTabPosYLow = 54;
	intTabPosX = System.StringToInteger(groupTabThinger.getXMLParam("x"));
}

initAnimation() {
	String stringDefaultTab = getDefaultTab();
	
	stringActiveTab = stringDefaultTab;
	stringActiveTabStatus = "SlidingDown";
	
	groupTabThinger.hide();
	groupTabEQ.hide();
	groupTabVis.hide();
	groupTabSettings.hide();
	
	if (stringDefaultTab == "Thinger") { fadeDisplay(0); timerTabThinger.start(); }
	if (stringDefaultTab == "EQ") { fadeDisplay(255); timerTabEQ.start(); }
	if (stringDefaultTab == "Vis") { fadeDisplay(0); timerTabVis.start(); }
	if (stringDefaultTab == "Settings") { fadeDisplay(0); timerTabSettings.start(); }
}

moveTab(Group groupTab, Int intPosY) {
	groupTab.setTargetX(intTabPosX);
	groupTab.setTargetY(intPosY);
	groupTab.setTargetSpeed(getTabAnimationSpeed());
	groupTab.gotoTarget();
}

bringActiveTabDown(String stringNewActiveTab, Group groupTab, Timer timerTab, Boolean boolFadeDisplay) {
	stringActiveTab = stringNewActiveTab;
	System.setPrivateString("Mercury", "LastSelectedTab", stringActiveTab);
	moveTab(groupTab, intTabPosYLow);
	if (boolFadeDisplay) { fadeDisplay(255); }
	stringActiveTabStatus = "SlidingDown";
	timerTab.start();
}

bringActiveTabUp(Group groupTab, Group groupTabDummy, Int intPosY) {
	groupTabDummy.hide();
	groupTab.setXmlParam("y", System.integerToString(intTabPosYLow));
	groupTab.show();
	groupTab.bringToFront();
	moveTab(groupTab, intPosY);
	groupTabDummy.setXmlParam("y", System.integerToString(intPosY));
	stringActiveTabStatus = "SlidingUp";
}

finalizeDisplay(Timer timerTab, Int intPosY, boolean boolRestoreDisplay) {
	if (stringActiveTab != "Thinger") { finalizeDisplayUtil(groupTabDummyThinger, groupTabThinger, intPosY); }
	if (stringActiveTab != "EQ") { finalizeDisplayUtil(groupTabDummyEQ, groupTabEQ, intPosY); }
	if (stringActiveTab != "Vis") { finalizeDisplayUtil(groupTabDummyVis, groupTabVis, intPosY); }
	if (stringActiveTab != "Settings") { finalizeDisplayUtil(groupTabDummySettings, groupTabSettings, intPosY); }
	if (boolRestoreDisplay) { fadeDisplay(0); }
	stringActiveTabStatus = "";
	timerTab.stop();
}

finalizeDisplayUtil(Group groupTabDummy, Group groupTab, Int intPosY) {
	groupTabDummy.show();
	groupTab.hide();
	moveTab(groupTabDummy, intPosY);
}

fadeDisplay(Int intAlpha){
	layerDisplayScreen.setTargetA(intAlpha);
	layerDisplayScreen.setTargetSpeed(0.5);
	layerDisplayScreen.gotoTarget();
}

getDefaultTab() {
	String stringDefaultTab = "";
	stringDefaultTab = System.getPrivateString("Mercury", "DefaultTab", "Last Selected");
	if (stringDefaultTab == "Last Selected") stringDefaultTab = System.getPrivateString("Mercury", "LastSelectedTab", "Thinger");
	return stringDefaultTab;
}

getTabAnimationSpeed() {
	return (System.getPrivateInt("Mercury", "TabAnimationSpeed", 128)  / 2.55 * 0.01);
}

catchTimer(Group groupTabDummy, Group groupTab, Timer timerTab, Int intPosY, Boolean boolRestoreDisplay) {
	if (!groupTabDummy.isGoingToTarget() && stringActiveTabStatus == "SlidingDown") { bringActiveTabUp(groupTab, groupTabDummy, intPosY); }
	if (!groupTab.isGoingToTarget() && stringActiveTabStatus == "SlidingUp") { finalizeDisplay(timerTab, intPosY, boolRestoreDisplay); }
}

buttonTabDummyThinger.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("Thinger", groupTabDummyThinger, timerTabThinger, false); }
}

buttonTabDummyEQ.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("EQ", groupTabDummyEQ, timerTabEQ, true); }
}

buttonTabDummyVis.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("Vis", groupTabDummyVis, timerTabVis, false); }
}

buttonTabDummySettings.onLeftButtonUp(int x, int y) {
	if (stringActiveTabStatus == "") { bringActiveTabDown("Settings", groupTabDummySettings, timerTabSettings, false); }
}

timerTabThinger.onTimer() { catchTimer(groupTabDummyThinger, groupTabThinger, timerTabThinger, intTabPosYMed, true); }
timerTabEQ.onTimer() { catchTimer(groupTabDummyEQ, groupTabEQ, timerTabEQ, intTabPosYHigh, false); }
timerTabVis.onTimer() { catchTimer(groupTabDummyVis, groupTabVis, timerTabVis, intTabPosYMed, true); }
timerTabSettings.onTimer() { catchTimer(groupTabDummySettings, groupTabSettings, timerTabSettings, intTabPosYMed, true); }