#include "../../../lib/std.mi"

Function customVisUpdate(Int intValue);

Global Map mapVis;
Global Layer layerVisA;
Global Timer timerVis;

System.onScriptLoaded() {
	Layout layoutMainNormal = System.getContainer("main").getLayout("normal");
	Group groupDisplay = layoutMainNormal.getObject("player.normal.group.display");
	Group groupTabs = groupDisplay.getObject("player.normal.group.display.tabs");
	Group groupVisTab = groupTabs.getObject("player.normal.group.display.tab.vis");
	
	Group groupVisA = groupVisTab.getObject("player.normal.group.display.vis.custom.a");
	layerVisA = groupVisA.getObject("VisLayer");
	
	mapVis = new Map;
	mapVis.loadMap("player.normal.display.vis.custom.map");
	
	timerVis = new Timer;
	timerVis.setDelay(25);
	timerVis.start();
}

System.onScriptUnloading() {
	delete mapVis;
	delete timerVis;
}

timerVis.onTimer() {
	Int intPlayItemLength = System.getPlayItemLength();
	if (intPlayItemLength > 0) {
		customVisUpdate((System.getLeftVuMeter() + System.getRightVuMeter() ) / 2);
	}
}

customVisUpdate(Int intValue) {
	Region regionMap = new Region;
	regionMap.loadFromMap(mapVis, intValue, 1);
	layerVisA.setRegion(regionMap);
	delete regionMap;
}
