#include "../../../lib/std.mi"
#include "../../../lib/AutoRepeatButton.m"

Function updateVolumeTicker(int intValue);
Function getVolumeChangeRate();
Function setDisplayText(String stringText, String stringTextAbbr);

Global AutoRepeatButton buttonNormalVolumeUp, buttonNormalVolumeDown;
Global Slider sliderNormalHiddenVolume, sliderClassicVolume, sliderStickVolume;
Global Timer timerSongTicker;
Global Text textNormalSongTicker, textClassicSongTicker, textStickSongTicker, textMiniSongTicker;

Global float floatCurrentVolume;

System.onScriptLoaded() {
	AutoRepeat_Load();
	
	Layout layoutMainNormal = System.getContainer("main").getLayout("normal");
	Layout layoutMainClassic = System.getContainer("main").getLayout("classic");
	Layout layoutMainStick = System.getContainer("main").getLayout("stick");
	Layout layoutMainMini = System.getContainer("main").getLayout("mini");
	
	Group groupNormalButtons = layoutMainNormal.getObject("player.normal.group.buttons");
	Group groupNormalDisplay = layoutMainNormal.getObject("player.normal.group.display");
	
	Group groupClassicButtons = layoutMainClassic.getObject("player.classic.group.buttons");
	Group groupClassicDisplay = layoutMainClassic.getObject("player.classic.group.display");
	
	Group groupStickButtons = layoutMainStick.getObject("player.stick.group.buttons");
	Group groupStickDisplay = layoutMainStick.getObject("player.stick.group.display");
	
	Group groupMiniDisplay = layoutMainMini.getObject("player.mini.group.display");
	
	buttonNormalVolumeUp = groupNormalButtons.getObject("ButtonVolumeUp");
	buttonNormalVolumeDown = groupNormalButtons.getObject("ButtonVolumeDown");
	sliderNormalHiddenVolume = groupNormalButtons.getObject("SliderVolume");
	textNormalSongTicker = groupNormalDisplay.getObject("PlayerInfoLine");
	
	sliderClassicVolume = groupClassicButtons.getObject("SliderVolume");
	textClassicSongTicker = groupClassicDisplay.getObject("PlayerInfoLine");
	
	sliderStickVolume = groupStickButtons.getObject("SliderVolume");
	textStickSongTicker = groupStickDisplay.getObject("PlayerSongTicker");
	
	textMiniSongTicker = groupMiniDisplay.getObject("PlayerTimer");
	
	timerSongTicker = new Timer;
  
	floatCurrentVolume = System.GetVolume();
	updateVolumeTicker(floatCurrentVolume/2.55);
}

System.onScriptUnLoading() {
	AutoRepeat_UnLoad();
	delete timerSongTicker;
}

System.onVolumeChanged(int newvol) {
	if (System.integer(floatCurrentVolume) != newvol) {
		floatCurrentVolume = Newvol;
	}
}

timerSongTicker.onTimer() {
	setDisplayText("", "");
}

buttonNormalVolumeUp.onLeftClick() {
	if (AutoRepeat_ClickType != 0) {
		floatCurrentVolume = floatCurrentVolume + getVolumeChangeRate();
		System.SetVolume(System.integer(floatCurrentVolume));
		updateVolumeTicker(floatCurrentVolume/2.55);
	}
}

buttonNormalVolumeDown.onLeftClick() {
	if (AutoRepeat_ClickType != 0) {
		floatCurrentVolume = floatCurrentVolume - getVolumeChangeRate();
		System.SetVolume(System.integer(floatCurrentVolume));
		updateVolumeTicker(floatCurrentVolume/2.55);
	}
}

sliderNormalHiddenVolume.onPostedPosition(int intVolume) {
	updateVolumeTicker(intVolume/2.55);
}

sliderClassicVolume.onPostedPosition(int intVolume) {
	updateVolumeTicker(intVolume/2.55);
}

sliderStickVolume.onPostedPosition(int intVolume) {
	updateVolumeTicker(intVolume/2.55);
}

updateVolumeTicker(int intValue) {
	timerSongTicker.stop();
	timerSongTicker.start();
	setDisplayText("Volume:  " + System.integerToString(intValue) + "%", System.integerToString(intValue) + "%");
}

setDisplayText(String stringText, String stringTextAbbr) {
	textNormalSongTicker.setAlternateText(stringText);
	textClassicSongTicker.setAlternateText(stringText);
	textStickSongTicker.setAlternateText(stringText);
	textMiniSongTicker.setAlternateText(stringTextAbbr);
}

getVolumeChangeRate() {
	return System.getPrivateInt("Mercury", "VolumeButtonRate", 1);
}